<template>
  <el-select
    v-model="selected"
    class="course-select"
    :placeholder="placeholder"
    filterable
    :clearable="clearable"
    :disabled="disabled"
    @change="select"
  >
    <el-option
      v-for="(item, index) in optionList"
      :key="index"
      :value="item.code"
      :label="`${item.name}（${item.code}）`"
    >
      <span>{{ `${item.name}（${item.code}）` }}</span>
    </el-option>
  </el-select>
</template>

<script>
import { conditionListCourse } from "../../modules/base/api";
import { objFilterNull } from "../../plugins/utils";
// import { courseQuery } from "../../modules/base/api";

export default {
  name: "course-select",
  props: {
    disabled: { type: Boolean, default: false },
    placeholder: { type: String, default: "请选择" },
    value: { type: [Number, String], default: "" },
    clearable: { type: Boolean, default: true },
    semesterId: { type: String, default: "" },
    examId: { type: String, default: "" },
    printPlanId: { type: [String, Array], default: "" },
  },
  data() {
    return {
      optionList: [],
      selected: "",
    };
  },
  watch: {
    value: {
      immediate: true,
      handler(val) {
        this.selected = val;
      },
    },
    semesterId(val, oldval) {
      if (val !== oldval) {
        this.search();
        this.$emit("input", "");
        this.$emit("change", {});
      }
    },
    examId(val, oldval) {
      if (val !== oldval) {
        this.search();
        this.$emit("input", "");
        this.$emit("change", {});
      }
    },
    printPlanId(val, oldval) {
      if (val !== oldval) {
        this.search();
        this.$emit("input", "");
        this.$emit("change", {});
      }
    },
  },
  async created() {
    this.search();
  },
  methods: {
    async search() {
      let data = {
        semesterId: this.semesterId,
        examId: this.examId,
        printPlanId: this.printPlanId,
      };

      const res = await conditionListCourse(objFilterNull(data));
      this.optionList = res;
    },
    select() {
      this.$emit("input", this.selected);
      this.$emit(
        "change",
        this.optionList.find((item) => item.code === this.selected)
      );
    },
  },
};
</script>
